unit ARForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Resources,MSXE3021WebReference.MSXE302x,System.Net.Sockets,sysutils;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    components: System.ComponentModel.IContainer;
    GB_Description: System.Windows.Forms.GroupBox;
    Label1: System.Windows.Forms.Label;
    GB_Help: System.Windows.Forms.GroupBox;
    Label2: System.Windows.Forms.Label;
    Label3: System.Windows.Forms.Label;
    TB_IPAddress0: System.Windows.Forms.TextBox;
    TB_IPAddress1: System.Windows.Forms.TextBox;
    Label4: System.Windows.Forms.Label;
    TB_IPAddress2: System.Windows.Forms.TextBox;
    TB_IPAddress3: System.Windows.Forms.TextBox;
    Label5: System.Windows.Forms.Label;
    Label6: System.Windows.Forms.Label;
    B_Start: System.Windows.Forms.Button;
    B_Stop: System.Windows.Forms.Button;
    GB_ChannelConfiguration: System.Windows.Forms.GroupBox;
    Label7: System.Windows.Forms.Label;
    Label8: System.Windows.Forms.Label;
    Label9: System.Windows.Forms.Label;
    CB_Ch0: System.Windows.Forms.CheckBox;
    CB_Ch1: System.Windows.Forms.CheckBox;
    CB_Ch2: System.Windows.Forms.CheckBox;
    CB_Ch3: System.Windows.Forms.CheckBox;
    CB_Ch4: System.Windows.Forms.CheckBox;
    CB_Ch5: System.Windows.Forms.CheckBox;
    CB_Ch6: System.Windows.Forms.CheckBox;
    CB_Ch7: System.Windows.Forms.CheckBox;
    CB_Ch8: System.Windows.Forms.CheckBox;
    CB_Ch9: System.Windows.Forms.CheckBox;
    CB_Ch10: System.Windows.Forms.CheckBox;
    CB_Ch11: System.Windows.Forms.CheckBox;
    CB_Ch12: System.Windows.Forms.CheckBox;
    CB_Ch13: System.Windows.Forms.CheckBox;
    CB_Ch14: System.Windows.Forms.CheckBox;
    CB_Ch15: System.Windows.Forms.CheckBox;
    CB_Gain0: System.Windows.Forms.ComboBox;
    CB_Gain1: System.Windows.Forms.ComboBox;
    CB_Gain2: System.Windows.Forms.ComboBox;
    CB_Gain3: System.Windows.Forms.ComboBox;
    CB_Gain4: System.Windows.Forms.ComboBox;
    CB_Gain5: System.Windows.Forms.ComboBox;
    CB_Gain6: System.Windows.Forms.ComboBox;
    CB_Gain7: System.Windows.Forms.ComboBox;
    CB_Gain8: System.Windows.Forms.ComboBox;
    CB_Gain9: System.Windows.Forms.ComboBox;
    CB_Gain10: System.Windows.Forms.ComboBox;
    CB_Gain11: System.Windows.Forms.ComboBox;
    CB_Gain12: System.Windows.Forms.ComboBox;
    CB_Gain13: System.Windows.Forms.ComboBox;
    CB_Gain14: System.Windows.Forms.ComboBox;
    CB_Gain15: System.Windows.Forms.ComboBox;
    CB_Pol0: System.Windows.Forms.ComboBox;
    CB_Pol1: System.Windows.Forms.ComboBox;
    CB_Pol2: System.Windows.Forms.ComboBox;
    CB_Pol3: System.Windows.Forms.ComboBox;
    CB_Pol4: System.Windows.Forms.ComboBox;
    CB_Pol5: System.Windows.Forms.ComboBox;
    CB_Pol6: System.Windows.Forms.ComboBox;
    CB_Pol7: System.Windows.Forms.ComboBox;
    CB_Pol8: System.Windows.Forms.ComboBox;
    CB_Pol9: System.Windows.Forms.ComboBox;
    CB_Pol10: System.Windows.Forms.ComboBox;
    CB_Pol11: System.Windows.Forms.ComboBox;
    CB_Pol12: System.Windows.Forms.ComboBox;
    CB_Pol13: System.Windows.Forms.ComboBox;
    CB_Pol14: System.Windows.Forms.ComboBox;
    CB_Pol15: System.Windows.Forms.ComboBox;
    GB_TriggerConfiguration: System.Windows.Forms.GroupBox;
    Label10: System.Windows.Forms.Label;
    GB_DataFormat: System.Windows.Forms.GroupBox;
    CB_TimeStamp: System.Windows.Forms.CheckBox;
    CB_ConvertInAnalogValue: System.Windows.Forms.CheckBox;
    GB_AverageConfiguration: System.Windows.Forms.GroupBox;
    GB_ConversionTimeConfiguration: System.Windows.Forms.GroupBox;
    Label11: System.Windows.Forms.Label;
    Label12: System.Windows.Forms.Label;
    Label13: System.Windows.Forms.Label;
    Label14: System.Windows.Forms.Label;
    Label15: System.Windows.Forms.Label;
    Label16: System.Windows.Forms.Label;
    Label17: System.Windows.Forms.Label;
    Label18: System.Windows.Forms.Label;
    TB_Display: System.Windows.Forms.TextBox;
    CB_TriggerMask: System.Windows.Forms.ComboBox;
    CB_HardwareTriggerEdge: System.Windows.Forms.ComboBox;
    TB_HardwareTriggerCount: System.Windows.Forms.TextBox;
    CB_TriggerMode: System.Windows.Forms.ComboBox;
    TB_NbrOfSeqForEachTrigger: System.Windows.Forms.TextBox;
    CB_AverageMode: System.Windows.Forms.ComboBox;
    TB_AverageValue: System.Windows.Forms.TextBox;
    CB_ConversionTimeUnit: System.Windows.Forms.ComboBox;
    TB_ConversionTimeValue: System.Windows.Forms.TextBox;
    Label19: System.Windows.Forms.Label;
    Timer1: System.Windows.Forms.Timer;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure TWinForm_Load(sender: System.Object; e: System.EventArgs);
    procedure TWinForm_Closed(sender: System.Object; e: System.EventArgs);
    procedure B_Start_Click(sender: System.Object; e: System.EventArgs);
    procedure TB_IPAddress0_Enter(sender: System.Object; e: System.EventArgs);
    procedure TB_IPAddress1_Enter(sender: System.Object; e: System.EventArgs);
    procedure TB_IPAddress2_Enter(sender: System.Object; e: System.EventArgs);
    procedure TB_IPAddress3_Enter(sender: System.Object; e: System.EventArgs);
    procedure B_Stop_Click(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch0_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_TriggerMask_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_TriggerMode_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure Timer1_Tick(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch1_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch2_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch3_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch4_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch5_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch6_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch7_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch8_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch9_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch10_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch11_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch12_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch13_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch14_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure CB_Ch15_CheckedChanged(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]


  var
  MSXE3021 : MSXE302x;
  i_SocketNbrOfBytesToReceive : Integer;
  i_SocketRequestBytes :Integer;
	i_SocketNbrOfReceiveBytes : Integer;
  SocketClient : TcpClient;
  stream : NetworkStream;
	Socketbuffer : Array [0..80] of Byte;
  ulDataFormat : UInt64;
  i_NbrOfChannel : Integer;


  implementation


{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
type
  TArrayOfSystem_Object = array of System.Object;
var
  resources: System.Resources.ResourceManager;
begin
  Self.components := System.ComponentModel.Container.Create;
  resources := System.Resources.ResourceManager.Create(TypeOf(TWinForm));
  Self.GB_Description := System.Windows.Forms.GroupBox.Create;
  Self.Label1 := System.Windows.Forms.Label.Create;
  Self.GB_Help := System.Windows.Forms.GroupBox.Create;
  Self.Label2 := System.Windows.Forms.Label.Create;
  Self.Label3 := System.Windows.Forms.Label.Create;
  Self.TB_IPAddress0 := System.Windows.Forms.TextBox.Create;
  Self.TB_IPAddress1 := System.Windows.Forms.TextBox.Create;
  Self.Label4 := System.Windows.Forms.Label.Create;
  Self.TB_IPAddress2 := System.Windows.Forms.TextBox.Create;
  Self.TB_IPAddress3 := System.Windows.Forms.TextBox.Create;
  Self.Label5 := System.Windows.Forms.Label.Create;
  Self.Label6 := System.Windows.Forms.Label.Create;
  Self.B_Start := System.Windows.Forms.Button.Create;
  Self.B_Stop := System.Windows.Forms.Button.Create;
  Self.GB_ChannelConfiguration := System.Windows.Forms.GroupBox.Create;
  Self.CB_Pol15 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol14 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol13 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol12 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol11 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol10 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol9 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol8 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol7 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol6 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol5 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol4 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol3 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol2 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol1 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Pol0 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain15 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain14 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain13 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain12 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain11 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain10 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain9 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain8 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain7 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain6 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain5 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain4 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain3 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain2 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain1 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Gain0 := System.Windows.Forms.ComboBox.Create;
  Self.CB_Ch15 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch14 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch13 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch12 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch11 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch10 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch9 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch8 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch7 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch6 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch5 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch4 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch3 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch2 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch1 := System.Windows.Forms.CheckBox.Create;
  Self.CB_Ch0 := System.Windows.Forms.CheckBox.Create;
  Self.Label9 := System.Windows.Forms.Label.Create;
  Self.Label8 := System.Windows.Forms.Label.Create;
  Self.Label7 := System.Windows.Forms.Label.Create;
  Self.GB_TriggerConfiguration := System.Windows.Forms.GroupBox.Create;
  Self.TB_NbrOfSeqForEachTrigger := System.Windows.Forms.TextBox.Create;
  Self.CB_TriggerMode := System.Windows.Forms.ComboBox.Create;
  Self.TB_HardwareTriggerCount := System.Windows.Forms.TextBox.Create;
  Self.CB_HardwareTriggerEdge := System.Windows.Forms.ComboBox.Create;
  Self.CB_TriggerMask := System.Windows.Forms.ComboBox.Create;
  Self.Label14 := System.Windows.Forms.Label.Create;
  Self.Label13 := System.Windows.Forms.Label.Create;
  Self.Label12 := System.Windows.Forms.Label.Create;
  Self.Label11 := System.Windows.Forms.Label.Create;
  Self.Label10 := System.Windows.Forms.Label.Create;
  Self.GB_DataFormat := System.Windows.Forms.GroupBox.Create;
  Self.CB_ConvertInAnalogValue := System.Windows.Forms.CheckBox.Create;
  Self.CB_TimeStamp := System.Windows.Forms.CheckBox.Create;
  Self.GB_AverageConfiguration := System.Windows.Forms.GroupBox.Create;
  Self.TB_AverageValue := System.Windows.Forms.TextBox.Create;
  Self.CB_AverageMode := System.Windows.Forms.ComboBox.Create;
  Self.Label16 := System.Windows.Forms.Label.Create;
  Self.Label15 := System.Windows.Forms.Label.Create;
  Self.GB_ConversionTimeConfiguration := System.Windows.Forms.GroupBox.Create;
  Self.Label19 := System.Windows.Forms.Label.Create;
  Self.TB_ConversionTimeValue := System.Windows.Forms.TextBox.Create;
  Self.CB_ConversionTimeUnit := System.Windows.Forms.ComboBox.Create;
  Self.Label18 := System.Windows.Forms.Label.Create;
  Self.Label17 := System.Windows.Forms.Label.Create;
  Self.TB_Display := System.Windows.Forms.TextBox.Create;
  Self.Timer1 := System.Windows.Forms.Timer.Create(Self.components);
  Self.GB_Description.SuspendLayout;
  Self.GB_Help.SuspendLayout;
  Self.GB_ChannelConfiguration.SuspendLayout;
  Self.GB_TriggerConfiguration.SuspendLayout;
  Self.GB_DataFormat.SuspendLayout;
  Self.GB_AverageConfiguration.SuspendLayout;
  Self.GB_ConversionTimeConfiguration.SuspendLayout;
  Self.SuspendLayout;
  // 
  // GB_Description
  // 
  Self.GB_Description.Controls.Add(Self.Label1);
  Self.GB_Description.Location := System.Drawing.Point.Create(16, 8);
  Self.GB_Description.Name := 'GB_Description';
  Self.GB_Description.Size := System.Drawing.Size.Create(568, 56);
  Self.GB_Description.TabIndex := 0;
  Self.GB_Description.TabStop := False;
  Self.GB_Description.Text := 'Description';
  // 
  // Label1
  // 
  Self.Label1.Location := System.Drawing.Point.Create(16, 16);
  Self.Label1.Name := 'Label1';
  Self.Label1.Size := System.Drawing.Size.Create(536, 32);
  Self.Label1.TabIndex := 0;
  Self.Label1.Text := 'This sample permit to read several analog input in au' +
  'to-refresh mode';
  // 
  // GB_Help
  // 
  Self.GB_Help.Controls.Add(Self.Label2);
  Self.GB_Help.Location := System.Drawing.Point.Create(16, 72);
  Self.GB_Help.Name := 'GB_Help';
  Self.GB_Help.Size := System.Drawing.Size.Create(568, 56);
  Self.GB_Help.TabIndex := 1;
  Self.GB_Help.TabStop := False;
  Self.GB_Help.Text := 'Help';
  // 
  // Label2
  // 
  Self.Label2.Location := System.Drawing.Point.Create(8, 16);
  Self.Label2.Name := 'Label2';
  Self.Label2.Size := System.Drawing.Size.Create(552, 32);
  Self.Label2.TabIndex := 0;
  Self.Label2.Text := 'You must first enter the IP address of the MSX-E3021 ' +
  'module, than configure the auto-refresh and click on button "Start the sa' +
  'mple".';
  // 
  // Label3
  // 
  Self.Label3.Location := System.Drawing.Point.Create(24, 144);
  Self.Label3.Name := 'Label3';
  Self.Label3.Size := System.Drawing.Size.Create(200, 23);
  Self.Label3.TabIndex := 2;
  Self.Label3.Text := 'IP address of the MSX-E3021 module :';
  // 
  // TB_IPAddress0
  // 
  Self.TB_IPAddress0.Location := System.Drawing.Point.Create(224, 144);
  Self.TB_IPAddress0.Name := 'TB_IPAddress0';
  Self.TB_IPAddress0.Size := System.Drawing.Size.Create(56, 20);
  Self.TB_IPAddress0.TabIndex := 3;
  Self.TB_IPAddress0.Text := '';
  Include(Self.TB_IPAddress0.Enter, Self.TB_IPAddress0_Enter);
  // 
  // TB_IPAddress1
  // 
  Self.TB_IPAddress1.Location := System.Drawing.Point.Create(304, 144);
  Self.TB_IPAddress1.Name := 'TB_IPAddress1';
  Self.TB_IPAddress1.Size := System.Drawing.Size.Create(56, 20);
  Self.TB_IPAddress1.TabIndex := 4;
  Self.TB_IPAddress1.Text := '';
  Include(Self.TB_IPAddress1.Enter, Self.TB_IPAddress1_Enter);
  // 
  // Label4
  // 
  Self.Label4.Location := System.Drawing.Point.Create(288, 152);
  Self.Label4.Name := 'Label4';
  Self.Label4.Size := System.Drawing.Size.Create(8, 8);
  Self.Label4.TabIndex := 5;
  Self.Label4.Text := '-';
  // 
  // TB_IPAddress2
  // 
  Self.TB_IPAddress2.Location := System.Drawing.Point.Create(384, 144);
  Self.TB_IPAddress2.Name := 'TB_IPAddress2';
  Self.TB_IPAddress2.Size := System.Drawing.Size.Create(56, 20);
  Self.TB_IPAddress2.TabIndex := 6;
  Self.TB_IPAddress2.Text := '';
  Include(Self.TB_IPAddress2.Enter, Self.TB_IPAddress2_Enter);
  // 
  // TB_IPAddress3
  // 
  Self.TB_IPAddress3.Location := System.Drawing.Point.Create(464, 144);
  Self.TB_IPAddress3.Name := 'TB_IPAddress3';
  Self.TB_IPAddress3.Size := System.Drawing.Size.Create(56, 20);
  Self.TB_IPAddress3.TabIndex := 7;
  Self.TB_IPAddress3.Text := '';
  Include(Self.TB_IPAddress3.Enter, Self.TB_IPAddress3_Enter);
  // 
  // Label5
  // 
  Self.Label5.Location := System.Drawing.Point.Create(368, 152);
  Self.Label5.Name := 'Label5';
  Self.Label5.Size := System.Drawing.Size.Create(8, 8);
  Self.Label5.TabIndex := 8;
  Self.Label5.Text := '-';
  // 
  // Label6
  // 
  Self.Label6.Location := System.Drawing.Point.Create(448, 152);
  Self.Label6.Name := 'Label6';
  Self.Label6.Size := System.Drawing.Size.Create(8, 8);
  Self.Label6.TabIndex := 9;
  Self.Label6.Text := '-';
  // 
  // B_Start
  // 
  Self.B_Start.Location := System.Drawing.Point.Create(16, 192);
  Self.B_Start.Name := 'B_Start';
  Self.B_Start.Size := System.Drawing.Size.Create(256, 23);
  Self.B_Start.TabIndex := 10;
  Self.B_Start.Text := '&Start the sample';
  Include(Self.B_Start.Click, Self.B_Start_Click);
  // 
  // B_Stop
  // 
  Self.B_Stop.Location := System.Drawing.Point.Create(296, 192);
  Self.B_Stop.Name := 'B_Stop';
  Self.B_Stop.Size := System.Drawing.Size.Create(256, 23);
  Self.B_Stop.TabIndex := 11;
  Self.B_Stop.Text := 'Sto&p the sample';
  Include(Self.B_Stop.Click, Self.B_Stop_Click);
  // 
  // GB_ChannelConfiguration
  // 
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol15);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol14);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol13);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol12);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol11);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol10);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol9);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol8);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol7);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol6);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol5);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol4);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol3);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol2);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol1);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Pol0);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain15);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain14);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain13);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain12);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain11);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain10);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain9);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain8);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain7);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain6);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain5);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain4);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain3);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain2);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain1);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Gain0);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch15);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch14);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch13);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch12);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch11);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch10);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch9);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch8);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch7);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch6);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch5);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch4);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch3);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch2);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch1);
  Self.GB_ChannelConfiguration.Controls.Add(Self.CB_Ch0);
  Self.GB_ChannelConfiguration.Controls.Add(Self.Label9);
  Self.GB_ChannelConfiguration.Controls.Add(Self.Label8);
  Self.GB_ChannelConfiguration.Controls.Add(Self.Label7);
  Self.GB_ChannelConfiguration.Location := System.Drawing.Point.Create(16, 224);
  Self.GB_ChannelConfiguration.Name := 'GB_ChannelConfiguration';
  Self.GB_ChannelConfiguration.Size := System.Drawing.Size.Create(920, 128);
  Self.GB_ChannelConfiguration.TabIndex := 12;
  Self.GB_ChannelConfiguration.TabStop := False;
  Self.GB_ChannelConfiguration.Text := 'Channel configuration';
  // 
  // CB_Pol15
  // 
  Self.CB_Pol15.Enabled := False;
  Self.CB_Pol15.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol15.Location := System.Drawing.Point.Create(856, 88);
  Self.CB_Pol15.Name := 'CB_Pol15';
  Self.CB_Pol15.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol15.TabIndex := 50;
  Self.CB_Pol15.Text := 'Uni';
  // 
  // CB_Pol14
  // 
  Self.CB_Pol14.Enabled := False;
  Self.CB_Pol14.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol14.Location := System.Drawing.Point.Create(800, 88);
  Self.CB_Pol14.Name := 'CB_Pol14';
  Self.CB_Pol14.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol14.TabIndex := 49;
  Self.CB_Pol14.Text := 'Uni';
  // 
  // CB_Pol13
  // 
  Self.CB_Pol13.Enabled := False;
  Self.CB_Pol13.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol13.Location := System.Drawing.Point.Create(744, 88);
  Self.CB_Pol13.Name := 'CB_Pol13';
  Self.CB_Pol13.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol13.TabIndex := 48;
  Self.CB_Pol13.Text := 'Uni';
  // 
  // CB_Pol12
  // 
  Self.CB_Pol12.Enabled := False;
  Self.CB_Pol12.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol12.Location := System.Drawing.Point.Create(688, 88);
  Self.CB_Pol12.Name := 'CB_Pol12';
  Self.CB_Pol12.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol12.TabIndex := 47;
  Self.CB_Pol12.Text := 'Uni';
  // 
  // CB_Pol11
  // 
  Self.CB_Pol11.Enabled := False;
  Self.CB_Pol11.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol11.Location := System.Drawing.Point.Create(632, 88);
  Self.CB_Pol11.Name := 'CB_Pol11';
  Self.CB_Pol11.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol11.TabIndex := 46;
  Self.CB_Pol11.Text := 'Uni';
  // 
  // CB_Pol10
  // 
  Self.CB_Pol10.Enabled := False;
  Self.CB_Pol10.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol10.Location := System.Drawing.Point.Create(576, 88);
  Self.CB_Pol10.Name := 'CB_Pol10';
  Self.CB_Pol10.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol10.TabIndex := 45;
  Self.CB_Pol10.Text := 'Uni';
  // 
  // CB_Pol9
  // 
  Self.CB_Pol9.Enabled := False;
  Self.CB_Pol9.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol9.Location := System.Drawing.Point.Create(528, 88);
  Self.CB_Pol9.Name := 'CB_Pol9';
  Self.CB_Pol9.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol9.TabIndex := 44;
  Self.CB_Pol9.Text := 'Uni';
  // 
  // CB_Pol8
  // 
  Self.CB_Pol8.Enabled := False;
  Self.CB_Pol8.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol8.Location := System.Drawing.Point.Create(480, 88);
  Self.CB_Pol8.Name := 'CB_Pol8';
  Self.CB_Pol8.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol8.TabIndex := 43;
  Self.CB_Pol8.Text := 'Uni';
  // 
  // CB_Pol7
  // 
  Self.CB_Pol7.Enabled := False;
  Self.CB_Pol7.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol7.Location := System.Drawing.Point.Create(432, 88);
  Self.CB_Pol7.Name := 'CB_Pol7';
  Self.CB_Pol7.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol7.TabIndex := 42;
  Self.CB_Pol7.Text := 'Uni';
  // 
  // CB_Pol6
  // 
  Self.CB_Pol6.Enabled := False;
  Self.CB_Pol6.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol6.Location := System.Drawing.Point.Create(384, 88);
  Self.CB_Pol6.Name := 'CB_Pol6';
  Self.CB_Pol6.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol6.TabIndex := 41;
  Self.CB_Pol6.Text := 'Uni';
  // 
  // CB_Pol5
  // 
  Self.CB_Pol5.Enabled := False;
  Self.CB_Pol5.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol5.Location := System.Drawing.Point.Create(336, 88);
  Self.CB_Pol5.Name := 'CB_Pol5';
  Self.CB_Pol5.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol5.TabIndex := 40;
  Self.CB_Pol5.Text := 'Uni';
  // 
  // CB_Pol4
  // 
  Self.CB_Pol4.Enabled := False;
  Self.CB_Pol4.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol4.Location := System.Drawing.Point.Create(288, 88);
  Self.CB_Pol4.Name := 'CB_Pol4';
  Self.CB_Pol4.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol4.TabIndex := 39;
  Self.CB_Pol4.Text := 'Uni';
  // 
  // CB_Pol3
  // 
  Self.CB_Pol3.Enabled := False;
  Self.CB_Pol3.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol3.Location := System.Drawing.Point.Create(240, 88);
  Self.CB_Pol3.Name := 'CB_Pol3';
  Self.CB_Pol3.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol3.TabIndex := 38;
  Self.CB_Pol3.Text := 'Uni';
  // 
  // CB_Pol2
  // 
  Self.CB_Pol2.Enabled := False;
  Self.CB_Pol2.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol2.Location := System.Drawing.Point.Create(192, 88);
  Self.CB_Pol2.Name := 'CB_Pol2';
  Self.CB_Pol2.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol2.TabIndex := 37;
  Self.CB_Pol2.Text := 'Uni';
  // 
  // CB_Pol1
  // 
  Self.CB_Pol1.Enabled := False;
  Self.CB_Pol1.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol1.Location := System.Drawing.Point.Create(136, 88);
  Self.CB_Pol1.Name := 'CB_Pol1';
  Self.CB_Pol1.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol1.TabIndex := 36;
  Self.CB_Pol1.Text := 'Uni';
  // 
  // CB_Pol0
  // 
  Self.CB_Pol0.Items.AddRange(TArrayOfSystem_Object.Create('Uni', 'Bip'));
  Self.CB_Pol0.Location := System.Drawing.Point.Create(80, 88);
  Self.CB_Pol0.Name := 'CB_Pol0';
  Self.CB_Pol0.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Pol0.TabIndex := 35;
  Self.CB_Pol0.Text := 'Uni';
  // 
  // CB_Gain15
  // 
  Self.CB_Gain15.Enabled := False;
  Self.CB_Gain15.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain15.Location := System.Drawing.Point.Create(856, 48);
  Self.CB_Gain15.Name := 'CB_Gain15';
  Self.CB_Gain15.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain15.TabIndex := 34;
  Self.CB_Gain15.Text := '1';
  // 
  // CB_Gain14
  // 
  Self.CB_Gain14.Enabled := False;
  Self.CB_Gain14.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain14.Location := System.Drawing.Point.Create(800, 48);
  Self.CB_Gain14.Name := 'CB_Gain14';
  Self.CB_Gain14.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain14.TabIndex := 33;
  Self.CB_Gain14.Text := '1';
  // 
  // CB_Gain13
  // 
  Self.CB_Gain13.Enabled := False;
  Self.CB_Gain13.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain13.Location := System.Drawing.Point.Create(744, 48);
  Self.CB_Gain13.Name := 'CB_Gain13';
  Self.CB_Gain13.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain13.TabIndex := 32;
  Self.CB_Gain13.Text := '1';
  // 
  // CB_Gain12
  // 
  Self.CB_Gain12.Enabled := False;
  Self.CB_Gain12.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain12.Location := System.Drawing.Point.Create(688, 48);
  Self.CB_Gain12.Name := 'CB_Gain12';
  Self.CB_Gain12.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain12.TabIndex := 31;
  Self.CB_Gain12.Text := '1';
  // 
  // CB_Gain11
  // 
  Self.CB_Gain11.Enabled := False;
  Self.CB_Gain11.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain11.Location := System.Drawing.Point.Create(632, 48);
  Self.CB_Gain11.Name := 'CB_Gain11';
  Self.CB_Gain11.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain11.TabIndex := 30;
  Self.CB_Gain11.Text := '1';
  // 
  // CB_Gain10
  // 
  Self.CB_Gain10.Enabled := False;
  Self.CB_Gain10.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain10.Location := System.Drawing.Point.Create(576, 48);
  Self.CB_Gain10.Name := 'CB_Gain10';
  Self.CB_Gain10.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain10.TabIndex := 29;
  Self.CB_Gain10.Text := '1';
  // 
  // CB_Gain9
  // 
  Self.CB_Gain9.Enabled := False;
  Self.CB_Gain9.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain9.Location := System.Drawing.Point.Create(528, 48);
  Self.CB_Gain9.Name := 'CB_Gain9';
  Self.CB_Gain9.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain9.TabIndex := 28;
  Self.CB_Gain9.Text := '1';
  // 
  // CB_Gain8
  // 
  Self.CB_Gain8.Enabled := False;
  Self.CB_Gain8.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain8.Location := System.Drawing.Point.Create(480, 48);
  Self.CB_Gain8.Name := 'CB_Gain8';
  Self.CB_Gain8.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain8.TabIndex := 27;
  Self.CB_Gain8.Text := '1';
  // 
  // CB_Gain7
  // 
  Self.CB_Gain7.Enabled := False;
  Self.CB_Gain7.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain7.Location := System.Drawing.Point.Create(432, 48);
  Self.CB_Gain7.Name := 'CB_Gain7';
  Self.CB_Gain7.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain7.TabIndex := 26;
  Self.CB_Gain7.Text := '1';
  // 
  // CB_Gain6
  // 
  Self.CB_Gain6.Enabled := False;
  Self.CB_Gain6.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain6.Location := System.Drawing.Point.Create(384, 48);
  Self.CB_Gain6.Name := 'CB_Gain6';
  Self.CB_Gain6.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain6.TabIndex := 25;
  Self.CB_Gain6.Text := '1';
  // 
  // CB_Gain5
  // 
  Self.CB_Gain5.Enabled := False;
  Self.CB_Gain5.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain5.Location := System.Drawing.Point.Create(336, 48);
  Self.CB_Gain5.Name := 'CB_Gain5';
  Self.CB_Gain5.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain5.TabIndex := 24;
  Self.CB_Gain5.Text := '1';
  // 
  // CB_Gain4
  // 
  Self.CB_Gain4.Enabled := False;
  Self.CB_Gain4.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain4.Location := System.Drawing.Point.Create(288, 48);
  Self.CB_Gain4.Name := 'CB_Gain4';
  Self.CB_Gain4.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain4.TabIndex := 23;
  Self.CB_Gain4.Text := '1';
  // 
  // CB_Gain3
  // 
  Self.CB_Gain3.Enabled := False;
  Self.CB_Gain3.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain3.Location := System.Drawing.Point.Create(240, 48);
  Self.CB_Gain3.Name := 'CB_Gain3';
  Self.CB_Gain3.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain3.TabIndex := 22;
  Self.CB_Gain3.Text := '1';
  // 
  // CB_Gain2
  // 
  Self.CB_Gain2.Enabled := False;
  Self.CB_Gain2.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain2.Location := System.Drawing.Point.Create(192, 48);
  Self.CB_Gain2.Name := 'CB_Gain2';
  Self.CB_Gain2.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain2.TabIndex := 21;
  Self.CB_Gain2.Text := '1';
  // 
  // CB_Gain1
  // 
  Self.CB_Gain1.Enabled := False;
  Self.CB_Gain1.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain1.Location := System.Drawing.Point.Create(136, 48);
  Self.CB_Gain1.Name := 'CB_Gain1';
  Self.CB_Gain1.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain1.TabIndex := 20;
  Self.CB_Gain1.Text := '1';
  // 
  // CB_Gain0
  // 
  Self.CB_Gain0.Items.AddRange(TArrayOfSystem_Object.Create('1', '2'));
  Self.CB_Gain0.Location := System.Drawing.Point.Create(80, 48);
  Self.CB_Gain0.Name := 'CB_Gain0';
  Self.CB_Gain0.Size := System.Drawing.Size.Create(40, 21);
  Self.CB_Gain0.TabIndex := 19;
  Self.CB_Gain0.Text := '1';
  // 
  // CB_Ch15
  // 
  Self.CB_Ch15.Location := System.Drawing.Point.Create(856, 16);
  Self.CB_Ch15.Name := 'CB_Ch15';
  Self.CB_Ch15.Size := System.Drawing.Size.Create(56, 24);
  Self.CB_Ch15.TabIndex := 18;
  Self.CB_Ch15.Text := 'Ch 15';
  Include(Self.CB_Ch15.CheckedChanged, Self.CB_Ch15_CheckedChanged);
  // 
  // CB_Ch14
  // 
  Self.CB_Ch14.Location := System.Drawing.Point.Create(800, 16);
  Self.CB_Ch14.Name := 'CB_Ch14';
  Self.CB_Ch14.Size := System.Drawing.Size.Create(56, 24);
  Self.CB_Ch14.TabIndex := 17;
  Self.CB_Ch14.Text := 'Ch 14';
  Include(Self.CB_Ch14.CheckedChanged, Self.CB_Ch14_CheckedChanged);
  // 
  // CB_Ch13
  // 
  Self.CB_Ch13.Location := System.Drawing.Point.Create(744, 16);
  Self.CB_Ch13.Name := 'CB_Ch13';
  Self.CB_Ch13.Size := System.Drawing.Size.Create(56, 24);
  Self.CB_Ch13.TabIndex := 16;
  Self.CB_Ch13.Text := 'Ch 13';
  Include(Self.CB_Ch13.CheckedChanged, Self.CB_Ch13_CheckedChanged);
  // 
  // CB_Ch12
  // 
  Self.CB_Ch12.Location := System.Drawing.Point.Create(688, 16);
  Self.CB_Ch12.Name := 'CB_Ch12';
  Self.CB_Ch12.Size := System.Drawing.Size.Create(56, 24);
  Self.CB_Ch12.TabIndex := 15;
  Self.CB_Ch12.Text := 'Ch 12';
  Include(Self.CB_Ch12.CheckedChanged, Self.CB_Ch12_CheckedChanged);
  // 
  // CB_Ch11
  // 
  Self.CB_Ch11.Location := System.Drawing.Point.Create(632, 16);
  Self.CB_Ch11.Name := 'CB_Ch11';
  Self.CB_Ch11.Size := System.Drawing.Size.Create(56, 24);
  Self.CB_Ch11.TabIndex := 14;
  Self.CB_Ch11.Text := 'Ch 11';
  Include(Self.CB_Ch11.CheckedChanged, Self.CB_Ch11_CheckedChanged);
  // 
  // CB_Ch10
  // 
  Self.CB_Ch10.Location := System.Drawing.Point.Create(576, 16);
  Self.CB_Ch10.Name := 'CB_Ch10';
  Self.CB_Ch10.Size := System.Drawing.Size.Create(56, 24);
  Self.CB_Ch10.TabIndex := 13;
  Self.CB_Ch10.Text := 'Ch 10';
  Include(Self.CB_Ch10.CheckedChanged, Self.CB_Ch10_CheckedChanged);
  // 
  // CB_Ch9
  // 
  Self.CB_Ch9.Location := System.Drawing.Point.Create(528, 16);
  Self.CB_Ch9.Name := 'CB_Ch9';
  Self.CB_Ch9.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch9.TabIndex := 12;
  Self.CB_Ch9.Text := 'Ch 9';
  Include(Self.CB_Ch9.CheckedChanged, Self.CB_Ch9_CheckedChanged);
  // 
  // CB_Ch8
  // 
  Self.CB_Ch8.Location := System.Drawing.Point.Create(480, 16);
  Self.CB_Ch8.Name := 'CB_Ch8';
  Self.CB_Ch8.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch8.TabIndex := 11;
  Self.CB_Ch8.Text := 'Ch 8';
  Include(Self.CB_Ch8.CheckedChanged, Self.CB_Ch8_CheckedChanged);
  // 
  // CB_Ch7
  // 
  Self.CB_Ch7.Location := System.Drawing.Point.Create(432, 16);
  Self.CB_Ch7.Name := 'CB_Ch7';
  Self.CB_Ch7.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch7.TabIndex := 10;
  Self.CB_Ch7.Text := 'Ch 7';
  Include(Self.CB_Ch7.CheckedChanged, Self.CB_Ch7_CheckedChanged);
  // 
  // CB_Ch6
  // 
  Self.CB_Ch6.Location := System.Drawing.Point.Create(384, 16);
  Self.CB_Ch6.Name := 'CB_Ch6';
  Self.CB_Ch6.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch6.TabIndex := 9;
  Self.CB_Ch6.Text := 'Ch 6';
  Include(Self.CB_Ch6.CheckedChanged, Self.CB_Ch6_CheckedChanged);
  // 
  // CB_Ch5
  // 
  Self.CB_Ch5.Location := System.Drawing.Point.Create(336, 16);
  Self.CB_Ch5.Name := 'CB_Ch5';
  Self.CB_Ch5.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch5.TabIndex := 8;
  Self.CB_Ch5.Text := 'Ch 5';
  Include(Self.CB_Ch5.CheckedChanged, Self.CB_Ch5_CheckedChanged);
  // 
  // CB_Ch4
  // 
  Self.CB_Ch4.Location := System.Drawing.Point.Create(288, 16);
  Self.CB_Ch4.Name := 'CB_Ch4';
  Self.CB_Ch4.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch4.TabIndex := 7;
  Self.CB_Ch4.Text := 'Ch 4';
  Include(Self.CB_Ch4.CheckedChanged, Self.CB_Ch4_CheckedChanged);
  // 
  // CB_Ch3
  // 
  Self.CB_Ch3.Location := System.Drawing.Point.Create(240, 16);
  Self.CB_Ch3.Name := 'CB_Ch3';
  Self.CB_Ch3.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch3.TabIndex := 6;
  Self.CB_Ch3.Text := 'Ch 3';
  Include(Self.CB_Ch3.CheckedChanged, Self.CB_Ch3_CheckedChanged);
  // 
  // CB_Ch2
  // 
  Self.CB_Ch2.Location := System.Drawing.Point.Create(192, 16);
  Self.CB_Ch2.Name := 'CB_Ch2';
  Self.CB_Ch2.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch2.TabIndex := 5;
  Self.CB_Ch2.Text := 'Ch 2';
  Include(Self.CB_Ch2.CheckedChanged, Self.CB_Ch2_CheckedChanged);
  // 
  // CB_Ch1
  // 
  Self.CB_Ch1.Location := System.Drawing.Point.Create(136, 16);
  Self.CB_Ch1.Name := 'CB_Ch1';
  Self.CB_Ch1.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch1.TabIndex := 4;
  Self.CB_Ch1.Text := 'Ch 1';
  Include(Self.CB_Ch1.CheckedChanged, Self.CB_Ch1_CheckedChanged);
  // 
  // CB_Ch0
  // 
  Self.CB_Ch0.Checked := True;
  Self.CB_Ch0.CheckState := System.Windows.Forms.CheckState.Checked;
  Self.CB_Ch0.Location := System.Drawing.Point.Create(80, 16);
  Self.CB_Ch0.Name := 'CB_Ch0';
  Self.CB_Ch0.Size := System.Drawing.Size.Create(48, 24);
  Self.CB_Ch0.TabIndex := 3;
  Self.CB_Ch0.Text := 'Ch 0';
  Include(Self.CB_Ch0.CheckedChanged, Self.CB_Ch0_CheckedChanged);
  // 
  // Label9
  // 
  Self.Label9.AutoSize := True;
  Self.Label9.Location := System.Drawing.Point.Create(16, 88);
  Self.Label9.Name := 'Label9';
  Self.Label9.Size := System.Drawing.Size.Create(45, 16);
  Self.Label9.TabIndex := 2;
  Self.Label9.Text := 'Polarity:';
  // 
  // Label8
  // 
  Self.Label8.AutoSize := True;
  Self.Label8.Location := System.Drawing.Point.Create(16, 56);
  Self.Label8.Name := 'Label8';
  Self.Label8.Size := System.Drawing.Size.Create(31, 16);
  Self.Label8.TabIndex := 1;
  Self.Label8.Text := 'Gain:';
  // 
  // Label7
  // 
  Self.Label7.AutoSize := True;
  Self.Label7.Location := System.Drawing.Point.Create(16, 24);
  Self.Label7.Name := 'Label7';
  Self.Label7.Size := System.Drawing.Size.Create(50, 16);
  Self.Label7.TabIndex := 0;
  Self.Label7.Text := 'Channel:';
  // 
  // GB_TriggerConfiguration
  // 
  Self.GB_TriggerConfiguration.Controls.Add(Self.TB_NbrOfSeqForEachTrigger);
  Self.GB_TriggerConfiguration.Controls.Add(Self.CB_TriggerMode);
  Self.GB_TriggerConfiguration.Controls.Add(Self.TB_HardwareTriggerCount);
  Self.GB_TriggerConfiguration.Controls.Add(Self.CB_HardwareTriggerEdge);
  Self.GB_TriggerConfiguration.Controls.Add(Self.CB_TriggerMask);
  Self.GB_TriggerConfiguration.Controls.Add(Self.Label14);
  Self.GB_TriggerConfiguration.Controls.Add(Self.Label13);
  Self.GB_TriggerConfiguration.Controls.Add(Self.Label12);
  Self.GB_TriggerConfiguration.Controls.Add(Self.Label11);
  Self.GB_TriggerConfiguration.Controls.Add(Self.Label10);
  Self.GB_TriggerConfiguration.Location := System.Drawing.Point.Create(16, 368);
  Self.GB_TriggerConfiguration.Name := 'GB_TriggerConfiguration';
  Self.GB_TriggerConfiguration.Size := System.Drawing.Size.Create(344, 192);
  Self.GB_TriggerConfiguration.TabIndex := 13;
  Self.GB_TriggerConfiguration.TabStop := False;
  Self.GB_TriggerConfiguration.Text := 'Trigger configuration';
  // 
  // TB_NbrOfSeqForEachTrigger
  // 
  Self.TB_NbrOfSeqForEachTrigger.Enabled := False;
  Self.TB_NbrOfSeqForEachTrigger.Location := System.Drawing.Point.Create(256, 
      152);
  Self.TB_NbrOfSeqForEachTrigger.Name := 'TB_NbrOfSeqForEachTrigger';
  Self.TB_NbrOfSeqForEachTrigger.Size := System.Drawing.Size.Create(64, 20);
  Self.TB_NbrOfSeqForEachTrigger.TabIndex := 9;
  Self.TB_NbrOfSeqForEachTrigger.Text := '1';
  // 
  // CB_TriggerMode
  // 
  Self.CB_TriggerMode.Enabled := False;
  Self.CB_TriggerMode.Items.AddRange(TArrayOfSystem_Object.Create('Single sh' +
        'ot', 'Continuous'));
  Self.CB_TriggerMode.Location := System.Drawing.Point.Create(152, 128);
  Self.CB_TriggerMode.Name := 'CB_TriggerMode';
  Self.CB_TriggerMode.Size := System.Drawing.Size.Create(104, 21);
  Self.CB_TriggerMode.TabIndex := 8;
  Self.CB_TriggerMode.Text := 'Single shot';
  Include(Self.CB_TriggerMode.SelectedIndexChanged, Self.CB_TriggerMode_SelectedIndexChanged);
  // 
  // TB_HardwareTriggerCount
  // 
  Self.TB_HardwareTriggerCount.Enabled := False;
  Self.TB_HardwareTriggerCount.Location := System.Drawing.Point.Create(152, 96);
  Self.TB_HardwareTriggerCount.Name := 'TB_HardwareTriggerCount';
  Self.TB_HardwareTriggerCount.TabIndex := 7;
  Self.TB_HardwareTriggerCount.Text := '1';
  // 
  // CB_HardwareTriggerEdge
  // 
  Self.CB_HardwareTriggerEdge.Enabled := False;
  Self.CB_HardwareTriggerEdge.Items.AddRange(TArrayOfSystem_Object.Create('R' +
        'ising edge', 'Falling edge', 'Both edge'));
  Self.CB_HardwareTriggerEdge.Location := System.Drawing.Point.Create(152, 64);
  Self.CB_HardwareTriggerEdge.Name := 'CB_HardwareTriggerEdge';
  Self.CB_HardwareTriggerEdge.Size := System.Drawing.Size.Create(104, 21);
  Self.CB_HardwareTriggerEdge.TabIndex := 6;
  Self.CB_HardwareTriggerEdge.Text := 'Rising edge';
  // 
  // CB_TriggerMask
  // 
  Self.CB_TriggerMask.Items.AddRange(TArrayOfSystem_Object.Create('No trigge' +
        'r', 'Digital input trigger', 'Synchro trigger'));
  Self.CB_TriggerMask.Location := System.Drawing.Point.Create(152, 32);
  Self.CB_TriggerMask.Name := 'CB_TriggerMask';
  Self.CB_TriggerMask.Size := System.Drawing.Size.Create(104, 21);
  Self.CB_TriggerMask.TabIndex := 5;
  Self.CB_TriggerMask.Text := 'No trigger';
  Include(Self.CB_TriggerMask.SelectedIndexChanged, Self.CB_TriggerMask_SelectedIndexChanged);
  // 
  // Label14
  // 
  Self.Label14.AutoSize := True;
  Self.Label14.Location := System.Drawing.Point.Create(16, 160);
  Self.Label14.Name := 'Label14';
  Self.Label14.Size := System.Drawing.Size.Create(225, 16);
  Self.Label14.TabIndex := 4;
  Self.Label14.Text := 'Nbr of sequence to acquire for each trigger :';
  // 
  // Label13
  // 
  Self.Label13.AutoSize := True;
  Self.Label13.Location := System.Drawing.Point.Create(16, 128);
  Self.Label13.Name := 'Label13';
  Self.Label13.Size := System.Drawing.Size.Create(78, 16);
  Self.Label13.TabIndex := 3;
  Self.Label13.Text := 'Trigger mode :';
  // 
  // Label12
  // 
  Self.Label12.AutoSize := True;
  Self.Label12.Location := System.Drawing.Point.Create(16, 96);
  Self.Label12.Name := 'Label12';
  Self.Label12.Size := System.Drawing.Size.Create(125, 16);
  Self.Label12.TabIndex := 2;
  Self.Label12.Text := 'Hardware trigger count :';
  // 
  // Label11
  // 
  Self.Label11.AutoSize := True;
  Self.Label11.Location := System.Drawing.Point.Create(16, 64);
  Self.Label11.Name := 'Label11';
  Self.Label11.Size := System.Drawing.Size.Create(123, 16);
  Self.Label11.TabIndex := 1;
  Self.Label11.Text := 'Hardware trigger edge :';
  // 
  // Label10
  // 
  Self.Label10.AutoSize := True;
  Self.Label10.Location := System.Drawing.Point.Create(16, 32);
  Self.Label10.Name := 'Label10';
  Self.Label10.Size := System.Drawing.Size.Create(76, 16);
  Self.Label10.TabIndex := 0;
  Self.Label10.Text := 'Trigger mask :';
  // 
  // GB_DataFormat
  // 
  Self.GB_DataFormat.Controls.Add(Self.CB_ConvertInAnalogValue);
  Self.GB_DataFormat.Controls.Add(Self.CB_TimeStamp);
  Self.GB_DataFormat.Location := System.Drawing.Point.Create(368, 368);
  Self.GB_DataFormat.Name := 'GB_DataFormat';
  Self.GB_DataFormat.Size := System.Drawing.Size.Create(256, 80);
  Self.GB_DataFormat.TabIndex := 14;
  Self.GB_DataFormat.TabStop := False;
  Self.GB_DataFormat.Text := 'Data format';
  // 
  // CB_ConvertInAnalogValue
  // 
  Self.CB_ConvertInAnalogValue.Location := System.Drawing.Point.Create(32, 48);
  Self.CB_ConvertInAnalogValue.Name := 'CB_ConvertInAnalogValue';
  Self.CB_ConvertInAnalogValue.Size := System.Drawing.Size.Create(152, 24);
  Self.CB_ConvertInAnalogValue.TabIndex := 1;
  Self.CB_ConvertInAnalogValue.Text := 'Convert in analog value';
  // 
  // CB_TimeStamp
  // 
  Self.CB_TimeStamp.Location := System.Drawing.Point.Create(32, 16);
  Self.CB_TimeStamp.Name := 'CB_TimeStamp';
  Self.CB_TimeStamp.Size := System.Drawing.Size.Create(120, 24);
  Self.CB_TimeStamp.TabIndex := 0;
  Self.CB_TimeStamp.Text := 'With Time Stamp';
  // 
  // GB_AverageConfiguration
  // 
  Self.GB_AverageConfiguration.Controls.Add(Self.TB_AverageValue);
  Self.GB_AverageConfiguration.Controls.Add(Self.CB_AverageMode);
  Self.GB_AverageConfiguration.Controls.Add(Self.Label16);
  Self.GB_AverageConfiguration.Controls.Add(Self.Label15);
  Self.GB_AverageConfiguration.Location := System.Drawing.Point.Create(368, 464);
  Self.GB_AverageConfiguration.Name := 'GB_AverageConfiguration';
  Self.GB_AverageConfiguration.Size := System.Drawing.Size.Create(256, 96);
  Self.GB_AverageConfiguration.TabIndex := 15;
  Self.GB_AverageConfiguration.TabStop := False;
  Self.GB_AverageConfiguration.Text := 'Average configuration';
  // 
  // TB_AverageValue
  // 
  Self.TB_AverageValue.Location := System.Drawing.Point.Create(112, 56);
  Self.TB_AverageValue.Name := 'TB_AverageValue';
  Self.TB_AverageValue.TabIndex := 3;
  Self.TB_AverageValue.Text := '1';
  // 
  // CB_AverageMode
  // 
  Self.CB_AverageMode.Items.AddRange(TArrayOfSystem_Object.Create('No averag' +
        'e', 'Per sequence', 'Per channel'));
  Self.CB_AverageMode.Location := System.Drawing.Point.Create(112, 24);
  Self.CB_AverageMode.Name := 'CB_AverageMode';
  Self.CB_AverageMode.Size := System.Drawing.Size.Create(104, 21);
  Self.CB_AverageMode.TabIndex := 2;
  Self.CB_AverageMode.Text := 'No average';
  // 
  // Label16
  // 
  Self.Label16.AutoSize := True;
  Self.Label16.Location := System.Drawing.Point.Create(16, 56);
  Self.Label16.Name := 'Label16';
  Self.Label16.Size := System.Drawing.Size.Create(83, 16);
  Self.Label16.TabIndex := 1;
  Self.Label16.Text := 'Average value :';
  // 
  // Label15
  // 
  Self.Label15.AutoSize := True;
  Self.Label15.Location := System.Drawing.Point.Create(16, 24);
  Self.Label15.Name := 'Label15';
  Self.Label15.Size := System.Drawing.Size.Create(84, 16);
  Self.Label15.TabIndex := 0;
  Self.Label15.Text := 'Average mode :';
  // 
  // GB_ConversionTimeConfiguration
  // 
  Self.GB_ConversionTimeConfiguration.Controls.Add(Self.Label19);
  Self.GB_ConversionTimeConfiguration.Controls.Add(Self.TB_ConversionTimeValue);
  Self.GB_ConversionTimeConfiguration.Controls.Add(Self.CB_ConversionTimeUnit);
  Self.GB_ConversionTimeConfiguration.Controls.Add(Self.Label18);
  Self.GB_ConversionTimeConfiguration.Controls.Add(Self.Label17);
  Self.GB_ConversionTimeConfiguration.Location := System.Drawing.Point.Create(648, 
      368);
  Self.GB_ConversionTimeConfiguration.Name := 'GB_ConversionTimeConfiguratio' +
  'n';
  Self.GB_ConversionTimeConfiguration.Size := System.Drawing.Size.Create(288, 
      104);
  Self.GB_ConversionTimeConfiguration.TabIndex := 16;
  Self.GB_ConversionTimeConfiguration.TabStop := False;
  Self.GB_ConversionTimeConfiguration.Text := 'Conversion time configuration';
  // 
  // Label19
  // 
  Self.Label19.AutoSize := True;
  Self.Label19.Location := System.Drawing.Point.Create(152, 24);
  Self.Label19.Name := 'Label19';
  Self.Label19.Size := System.Drawing.Size.Create(61, 16);
  Self.Label19.TabIndex := 4;
  Self.Label19.Text := '(min 10 us)';
  // 
  // TB_ConversionTimeValue
  // 
  Self.TB_ConversionTimeValue.Location := System.Drawing.Point.Create(80, 56);
  Self.TB_ConversionTimeValue.Name := 'TB_ConversionTimeValue';
  Self.TB_ConversionTimeValue.Size := System.Drawing.Size.Create(56, 20);
  Self.TB_ConversionTimeValue.TabIndex := 3;
  Self.TB_ConversionTimeValue.Text := '40';
  // 
  // CB_ConversionTimeUnit
  // 
  Self.CB_ConversionTimeUnit.Items.AddRange(TArrayOfSystem_Object.Create('us', 
          'ms', 's'));
  Self.CB_ConversionTimeUnit.Location := System.Drawing.Point.Create(80, 24);
  Self.CB_ConversionTimeUnit.Name := 'CB_ConversionTimeUnit';
  Self.CB_ConversionTimeUnit.Size := System.Drawing.Size.Create(56, 21);
  Self.CB_ConversionTimeUnit.TabIndex := 2;
  Self.CB_ConversionTimeUnit.Text := 'us';
  // 
  // Label18
  // 
  Self.Label18.AutoSize := True;
  Self.Label18.Location := System.Drawing.Point.Create(16, 64);
  Self.Label18.Name := 'Label18';
  Self.Label18.Size := System.Drawing.Size.Create(63, 16);
  Self.Label18.TabIndex := 1;
  Self.Label18.Text := 'Time value:';
  // 
  // Label17
  // 
  Self.Label17.AutoSize := True;
  Self.Label17.Location := System.Drawing.Point.Create(16, 24);
  Self.Label17.Name := 'Label17';
  Self.Label17.Size := System.Drawing.Size.Create(54, 16);
  Self.Label17.TabIndex := 0;
  Self.Label17.Text := 'Time unit:';
  // 
  // TB_Display
  // 
  Self.TB_Display.Location := System.Drawing.Point.Create(16, 584);
  Self.TB_Display.Multiline := True;
  Self.TB_Display.Name := 'TB_Display';
  Self.TB_Display.ReadOnly := True;
  Self.TB_Display.ScrollBars := System.Windows.Forms.ScrollBars.Vertical;
  Self.TB_Display.Size := System.Drawing.Size.Create(920, 160);
  Self.TB_Display.TabIndex := 17;
  Self.TB_Display.Text := '';
  // 
  // Timer1
  // 
  Include(Self.Timer1.Tick, Self.Timer1_Tick);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(952, 742);
  Self.Controls.Add(Self.TB_Display);
  Self.Controls.Add(Self.TB_IPAddress3);
  Self.Controls.Add(Self.TB_IPAddress2);
  Self.Controls.Add(Self.TB_IPAddress1);
  Self.Controls.Add(Self.TB_IPAddress0);
  Self.Controls.Add(Self.GB_ConversionTimeConfiguration);
  Self.Controls.Add(Self.GB_AverageConfiguration);
  Self.Controls.Add(Self.GB_DataFormat);
  Self.Controls.Add(Self.GB_TriggerConfiguration);
  Self.Controls.Add(Self.GB_ChannelConfiguration);
  Self.Controls.Add(Self.B_Stop);
  Self.Controls.Add(Self.B_Start);
  Self.Controls.Add(Self.Label6);
  Self.Controls.Add(Self.Label5);
  Self.Controls.Add(Self.Label4);
  Self.Controls.Add(Self.Label3);
  Self.Controls.Add(Self.GB_Help);
  Self.Controls.Add(Self.GB_Description);
  Self.Icon := (System.Drawing.Icon(resources.GetObject('$this.Icon')));
  Self.Name := 'TWinForm';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.CenterScreen;
  Self.Text := 'Auto-Refresh Sample';
  Include(Self.Load, Self.TWinForm_Load);
  Include(Self.Closed, Self.TWinForm_Closed);
  Self.GB_Description.ResumeLayout(False);
  Self.GB_Help.ResumeLayout(False);
  Self.GB_ChannelConfiguration.ResumeLayout(False);
  Self.GB_TriggerConfiguration.ResumeLayout(False);
  Self.GB_DataFormat.ResumeLayout(False);
  Self.GB_AverageConfiguration.ResumeLayout(False);
  Self.GB_ConversionTimeConfiguration.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

function ConvertFromTime_T(time_t : UInt64) : DateTime;
var
  dt70 : DateTime;
  tickTotal : UInt64;
	netTimeT : DateTime;
Begin
			dt70 := DateTime.Create (1970,1,1,0,0,0,0);
			tickTotal := dt70.Ticks + (time_t * 10000000);
			netTimeT := DateTime.Create(tickTotal);
			ConvertFromTime_T:= netTimeT;
End;

function ConvertToTime_T (DotNetDate : DateTime):UInt64;
var
  dt70 : DateTime;
  tickTotal : Uint64;
Begin
			dt70 := DateTime.Create(1970,1,1,0,0,0,0);
			tickTotal := DotNetDate.Ticks - dt70.Ticks;
			tickTotal := tickTotal div 10000000;
			ConvertToTime_T := tickTotal;
End;

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TWinForm.CB_Ch15_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain15.Enabled := CheckBox(sender).Checked;
  CB_Pol15.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch14_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain14.Enabled := CheckBox(sender).Checked;
  CB_Pol14.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch13_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain13.Enabled := CheckBox(sender).Checked;
  CB_Pol13.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch12_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain12.Enabled := CheckBox(sender).Checked;
  CB_Pol12.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch11_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain11.Enabled := CheckBox(sender).Checked;
  CB_Pol11.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch10_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain10.Enabled := CheckBox(sender).Checked;
  CB_Pol10.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch9_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain9.Enabled := CheckBox(sender).Checked;
  CB_Pol9.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch8_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain8.Enabled := CheckBox(sender).Checked;
  CB_Pol8.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch7_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain7.Enabled := CheckBox(sender).Checked;
  CB_Pol7.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch6_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain6.Enabled := CheckBox(sender).Checked;
  CB_Pol6.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch5_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain5.Enabled := CheckBox(sender).Checked;
  CB_Pol5.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch4_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain4.Enabled := CheckBox(sender).Checked;
  CB_Pol4.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch3_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain3.Enabled := CheckBox(sender).Checked;
  CB_Pol3.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.CB_Ch2_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain2.Enabled := CheckBox(sender).Checked;
  CB_Pol2.Enabled := CheckBox(sender).Checked;

end;

procedure TWinForm.CB_Ch1_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain1.Enabled := CheckBox(sender).Checked;
  CB_Pol1.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.Timer1_Tick(sender: System.Object; e: System.EventArgs);
var
			i_Receive : Integer;
			ul_Value : UInt32;
			ul_Cpt : UInt32;
  		s_Value : Single;
			ulTimeStampLow : UInt64;
			ulTimeStampHigh : UInt64;
			ulTimeStampLowmus : UInt64;
			ulTimeStampLowms  : UInt64;
			ul_AutoRefreshCpt : UInt32;

begin

      i_Receive := 0;
			try

				// Test if data available
				if( stream.DataAvailable = true) then
					// Read the data
					i_Receive := stream.Read(Socketbuffer,(i_SocketNbrOfReceiveBytes div 4),i_SocketRequestBytes);
      except
        on Ex: Exception do
        Begin
 				TB_Display.Text := TB_Display.Text + Environment.NewLine + 'Exception occur : ' + ex.Message;
				B_Stop_Click(sender,e);
        end;
      end;

			if (i_Receive > 0) then
			Begin
				i_SocketNbrOfReceiveBytes := i_SocketNbrOfReceiveBytes + i_Receive;
				i_SocketRequestBytes := i_SocketRequestBytes - i_Receive;
			End;

			// Test if all value for 1 Sequence received
			if (i_SocketRequestBytes = 0) then
			Begin
				// Display the received value
				if (ulDataFormat = 0) then
				Begin
					ul_AutoRefreshCpt := BitConverter.ToUInt32(Socketbuffer,0);
					TB_Display.Text := 'Counter: ' + ul_AutoRefreshCpt.ToString();

					for ul_Cpt := 0 to i_NbrOfChannel - 1 do
					begin
						ul_Value := BitConverter.ToUInt32(Socketbuffer,(ul_Cpt * 4) + 4);
						TB_Display.Text := TB_Display.Text +' '+ ul_Value.ToString('X');
					end;
				end;
				if (ulDataFormat = 1) then
				Begin
					ulTimeStampHigh := BitConverter.ToUInt32(Socketbuffer,0);
					ulTimeStampLow := BitConverter.ToUInt32(Socketbuffer,4);
					ulTimeStampLowms := (ulTimeStampLow div 1000);
					ulTimeStampLowmus := (ulTimeStampLow mod 1000);
					TB_Display.Text := 'Time stamp: ' + ConvertFromTime_T(ulTimeStampHigh).ToString() + '.' + ulTimeStampLowms.ToString('D3') + '.' + ulTimeStampLowmus.ToString('D3');
					ul_AutoRefreshCpt := BitConverter.ToUInt32(Socketbuffer,8);
					TB_Display.Text := TB_Display.Text + ' Counter: ' + ul_AutoRefreshCpt.ToString();
					TB_Display.Text := TB_Display.Text + ' Channel value(s) :';
					for ul_Cpt := 0 to i_NbrOfChannel-1 do
					Begin
						ul_Value := BitConverter.ToUInt32(Socketbuffer,((ul_Cpt * 4)+12));
						TB_Display.Text := TB_Display.Text +' '+ ul_Value.ToString('X');
					End;

				End;
				if (ulDataFormat = 2) then
				Begin
					ul_AutoRefreshCpt := BitConverter.ToUInt32(Socketbuffer,0);
					TB_Display.Text := 'Counter: ' + ul_AutoRefreshCpt.ToString();
					TB_Display.Text := TB_Display.Text + ' Channel value(s) :';
					for ul_Cpt := 0 to i_NbrOfChannel - 1 do
					Begin
						s_Value := BitConverter.ToSingle(Socketbuffer,((ul_Cpt * 4)+4));
						TB_Display.Text := TB_Display.Text +' '+ FloatToStr(s_Value) +' V ';
					End;

				End;
				if (ulDataFormat = 3) then
				Begin
					ulTimeStampHigh := BitConverter.ToUInt32(Socketbuffer,0);
					ulTimeStampLow := BitConverter.ToUInt32(Socketbuffer,4);
					ulTimeStampLowms := (ulTimeStampLow div 1000);
					ulTimeStampLowmus := (ulTimeStampLow mod 1000);
					TB_Display.Text := 'Time stamp: ' + ConvertFromTime_T(ulTimeStampHigh).ToString() + '.' + ulTimeStampLowms.ToString('D3') + '.' + ulTimeStampLowmus.ToString('D3');
					ul_AutoRefreshCpt := BitConverter.ToUInt32(Socketbuffer,8);
					TB_Display.Text := TB_Display.Text + ' Counter: ' + ul_AutoRefreshCpt.ToString();
					TB_Display.Text := TB_Display.Text + ' Channel value(s) :';
					for ul_Cpt := 0  to i_NbrOfChannel - 1 do
					Begin
						s_Value := BitConverter.ToSingle(Socketbuffer,((ul_Cpt* 4)+ 12));
						TB_Display.Text := TB_Display.Text +' '+ FloatToStr(s_Value) + ' V ';
					End;

				End;
				TB_Display.Text := TB_Display.Text + Environment.NewLine;




				i_SocketNbrOfBytesToReceive := (i_NbrOfChannel * 4) + 4;
				if ((ulDataFormat = 1) or (ulDataFormat = 3)) then
					i_SocketNbrOfBytesToReceive := i_SocketNbrOfBytesToReceive + 8;

				i_SocketRequestBytes := i_SocketNbrOfBytesToReceive;
				i_SocketNbrOfReceiveBytes := 0;
			end;


end;

procedure TWinForm.CB_TriggerMode_SelectedIndexChanged(sender: System.Object;
  e: System.EventArgs);
begin
  	if(CB_TriggerMode.SelectedIndex = 1) then
		begin
      TB_NbrOfSeqForEachTrigger.Enabled := true;
    end
    else
		begin
				TB_NbrOfSeqForEachTrigger.Enabled := false;
    End;
end;

procedure TWinForm.CB_TriggerMask_SelectedIndexChanged(sender: System.Object;
  e: System.EventArgs);
begin
      if (CB_TriggerMask.SelectedIndex <> 0) then
    	Begin
				CB_TriggerMode.Enabled := true;
			end
			else
			Begin
				CB_TriggerMode.Enabled := false;
				TB_NbrOfSeqForEachTrigger.Enabled := false;
				CB_HardwareTriggerEdge.Enabled := false;
				TB_HardwareTriggerCount.Enabled := false;

			End;
			if (CB_TriggerMask.SelectedIndex = 1) then
			begin
				CB_HardwareTriggerEdge.Enabled := true;
				TB_HardwareTriggerCount.Enabled := true;
			end;
			if (CB_TriggerMask.SelectedIndex = 2) then
			begin
				CB_HardwareTriggerEdge.Enabled := false;
				TB_HardwareTriggerCount.Enabled := false;
			End;

			if (CB_TriggerMask.SelectedIndex = 3) then
			begin
				CB_HardwareTriggerEdge.Enabled := true;
				TB_HardwareTriggerCount.Enabled := true;
			end;
end;

procedure TWinForm.CB_Ch0_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  CB_Gain0.Enabled := CheckBox(sender).Checked;
  CB_Pol0.Enabled := CheckBox(sender).Checked;
end;

procedure TWinForm.B_Stop_Click(sender: System.Object; e: System.EventArgs);
var
  syserrno : Integer;
  i_Error : Integer;

begin

			Timer1.Enabled := false;
			try
				// Close the socket connection
				SocketClient.Close();
      except
        on E: Exception do MessageBox.Show('Exception occur : ' + e.Message, 'Function error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
      end;

			try
				i_Error := MSXE3021.AnalogInputStopAndReleaseAutoRefresh(syserrno);
				if (i_Error <> 0) then
					MessageBox.Show('AnalogInputStopAndReleaseAutoRefresh Error : ' + i_Error.ToString(), 'Function error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

      except
        on E: Exception do MessageBox.Show('Exception occur : ' + e.Message, 'Function error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
      end;

			GB_AverageConfiguration.Enabled := true;
			GB_ChannelConfiguration.Enabled := true;
			GB_ConversionTimeConfiguration.Enabled := true;
			GB_DataFormat.Enabled := true;
			GB_TriggerConfiguration.Enabled := true;
			B_Start.Enabled := true;
			B_Stop.Enabled := false;

end;

procedure TWinForm.TB_IPAddress3_Enter(sender: System.Object; e: System.EventArgs);
begin
  TB_IPAddress3.SelectAll();
end;

procedure TWinForm.TB_IPAddress2_Enter(sender: System.Object; e: System.EventArgs);
begin
  TB_IPAddress2.SelectAll();
end;

procedure TWinForm.TB_IPAddress1_Enter(sender: System.Object; e: System.EventArgs);
begin
  TB_IPAddress1.SelectAll();
end;

procedure TWinForm.TB_IPAddress0_Enter(sender: System.Object; e: System.EventArgs);
begin
  TB_IPAddress0.SelectAll();
end;

procedure TWinForm.B_Start_Click(sender: System.Object; e: System.EventArgs);
var
  ul_Cpt : LongWord;
  ulChannelMask : UInt64;
  ulTriggerMask : UInt64;
  ulHardwareTriggerEdge : UInt64;
  ulHardwareTriggerCount : UInt64;
  ulTriggerMode : UInt64;
  ulByTriggerNbrOfSeqToAcquire : UInt64;
  ulAverageMode : UInt64;
  ulAverageValue : UInt64;
  ulConversionTimeUnit : UInt64;
  ulConversionTime : UInt64;
  pulGain : MSXE3021WebReference.MSXE302x.unsignedLong16FixedArrayParam;
  pulPolarity : MSXE3021WebReference.MSXE302x.unsignedLong16FixedArrayParam;
  i_Error : Integer;
  syserrno : Integer;
  ulGain : Array[0..15] of UInt64;
  ulPolarity : Array[0..15] of UInt64;

begin
      ulChannelMask := 0;
      i_NbrOfChannel := 0;
      ulDataFormat := 0;
      ulHardwareTriggerEdge := 0;
      ulHardwareTriggerCount := 0;
      ulTriggerMode := 0;
      ulByTriggerNbrOfSeqToAcquire := 0;
      ulAverageValue := 0;
      pulGain := MSXE3021WebReference.MSXE302x.unsignedLong16FixedArrayParam.Create();
      pulPolarity := MSXE3021WebReference.MSXE302x.unsignedLong16FixedArrayParam.Create();
      pulGain.ulValue := ulGain;
      pulPolarity.ulValue := ulPolarity;


  		// CHANNEL CONFIGURATION
			for ul_Cpt := 0 to 15 do
      begin
				Case ul_Cpt of
					0:
						if CB_Ch0.Checked then
            Begin
							ulChannelMask := ulChannelMask or 1;
							pulGain.ulValue[ul_Cpt] := CB_Gain0.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol0.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
            end;
					1:
						if CB_Ch1.Checked then
						Begin
							ulChannelMask := ulChannelMask or 2;
							pulGain.ulValue[ul_Cpt] := CB_Gain1.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol1.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						end;
					2:
						if CB_Ch2.Checked then
						Begin
							ulChannelMask := ulChannelMask or 4;
							pulGain.ulValue[ul_Cpt] := CB_Gain2.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol2.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					3:
						if CB_Ch3.Checked then
						Begin
							ulChannelMask := ulChannelMask or 8;
							pulGain.ulValue[ul_Cpt] := CB_Gain3.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol3.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					4:
						if CB_Ch4.Checked then
						Begin
							ulChannelMask := ulChannelMask or 16;
							pulGain.ulValue[ul_Cpt] := CB_Gain4.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol4.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					5:
						if CB_Ch5.Checked then
						Begin
							ulChannelMask := ulChannelMask or 32;
							pulGain.ulValue[ul_Cpt] := CB_Gain5.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol5.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					6:
						if CB_Ch6.Checked then
						Begin
							ulChannelMask := ulChannelMask or 64;
							pulGain.ulValue[ul_Cpt] := CB_Gain6.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol6.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					7:
						if CB_Ch7.Checked then
						Begin
							ulChannelMask := ulChannelMask or 128;
							pulGain.ulValue[ul_Cpt] := CB_Gain7.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol7.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					8:
						if CB_Ch8.Checked then
						Begin
							ulChannelMask := ulChannelMask or 256;
							pulGain.ulValue[ul_Cpt] := CB_Gain8.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol8.SelectedIndex;
							i_NbrOfChannel:= i_NbrOfChannel + 1;
						End;
					9:
						if CB_Ch9.Checked then
						Begin
							ulChannelMask := ulChannelMask or 512;
							pulGain.ulValue[ul_Cpt] := CB_Gain9.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol9.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					10:
						if CB_Ch10.Checked then
						Begin
							ulChannelMask := ulChannelMask or 1024;
							pulGain.ulValue[ul_Cpt] := CB_Gain10.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol10.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					11:
						if CB_Ch11.Checked then
						Begin
							ulChannelMask := ulChannelMask or 2048;
							pulGain.ulValue[ul_Cpt] := CB_Gain11.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol11.SelectedIndex;
							i_NbrOfChannel:= i_NbrOfChannel + 1;
						End;
					12:
						if CB_Ch12.Checked then
						Begin
							ulChannelMask := ulChannelMask or 4096;
							pulGain.ulValue[ul_Cpt] := CB_Gain12.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol12.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					13:
						if CB_Ch13.Checked then
						Begin
							ulChannelMask := ulChannelMask or 8192;
							pulGain.ulValue[ul_Cpt] := CB_Gain13.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol13.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					14:
						if CB_Ch14.Checked then
						Begin
							ulChannelMask := ulChannelMask or 16384;
							pulGain.ulValue[ul_Cpt] := CB_Gain14.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol14.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
					15:
						if CB_Ch15.Checked then
						Begin
							ulChannelMask := ulChannelMask or 32768;
							pulGain.ulValue[ul_Cpt] := CB_Gain15.SelectedIndex + 1;
							pulPolarity.ulValue[ul_Cpt] := CB_Pol15.SelectedIndex;
							i_NbrOfChannel := i_NbrOfChannel + 1;
						End;
        End;
      end;


			// TRIGGER CONFIGURATION
			ulTriggerMask := CB_TriggerMask.SelectedIndex;
			if ((ulTriggerMask = 1) or (ulTriggerMask = 3)) then
			Begin
				ulHardwareTriggerEdge := CB_HardwareTriggerEdge.SelectedIndex + 1;
				ulHardwareTriggerCount := Convert.ToUInt64(TB_HardwareTriggerCount.Text.ToString(),10);
			End;

			if (ulTriggerMask <> 0) then
			Begin
				ulTriggerMode := CB_TriggerMode.SelectedIndex + 1;
				ulByTriggerNbrOfSeqToAcquire := Convert.ToUInt64(TB_NbrOfSeqForEachTrigger.Text.ToString(),10);
			End;

			// AVERAGE CONFIGURATION
			ulAverageMode := CB_AverageMode.SelectedIndex;
			if (ulAverageMode <> 0) then
			Begin
				ulAverageValue := Convert.ToUInt64(TB_AverageValue.Text.ToString(),10);
			End;

			// CONVERSION TIME CONFIGURATION
			ulConversionTimeUnit := CB_ConversionTimeUnit.SelectedIndex;
			ulConversionTime := Convert.ToUInt64(TB_ConversionTimeValue.Text.ToString(),10);

			// DATA FORMAT CONFIGURATION
			i_SocketNbrOfBytesToReceive := (i_NbrOfChannel * 4) + 4;

			if (CB_TimeStamp.Checked) then
			Begin
				ulDataFormat := ulDataFormat or 1;
				i_SocketNbrOfBytesToReceive := i_SocketNbrOfBytesToReceive + 8;
			end;
			if (CB_ConvertInAnalogValue.Checked) then
			begin
				ulDataFormat := ulDataFormat or 2;
			End;

			i_SocketRequestBytes := i_SocketNbrOfBytesToReceive;
			i_SocketNbrOfReceiveBytes := 0;



			if ((TB_IPAddress0.Text.ToString()= '') or (TB_IPAddress1.Text.ToString()= '') or (TB_IPAddress2.Text.ToString()= '') or (TB_IPAddress3.Text.ToString()= '')) then
			Begin
				MessageBox.Show('The IP address you enter is not valid, please try again.', 'IP address error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			End
			else
			Begin
				if ((Convert.ToUInt64(TB_IPAddress0.Text.ToString(),10) >= 0) and (Convert.ToUInt64(TB_IPAddress0.Text.ToString(),10) < 256)) then
				Begin
					if ((Convert.ToUInt64(TB_IPAddress1.Text.ToString(),10) >= 0) and (Convert.ToUInt64(TB_IPAddress1.Text.ToString(),10) < 256)) then
					Begin
						if ((Convert.ToUInt64(TB_IPAddress2.Text.ToString(),10) >= 0) and (Convert.ToUInt64(TB_IPAddress2.Text.ToString(),10) < 256)) then
						Begin
							if ((Convert.ToUInt64(TB_IPAddress3.Text.ToString(),10) >= 0) and (Convert.ToUInt64(TB_IPAddress3.Text.ToString(),10) < 256)) then
							Begin

								MSXE3021.Url := 'http:/' + TB_IPAddress0.Text + '.' + TB_IPAddress1.Text + '.'+ TB_IPAddress2.Text + '.' + TB_IPAddress3.Text + ':5555';

								TB_Display.Text := 'Open the socket and try to connect ...';
								TB_Display.Refresh();


                try
									// Open the socket connection to receive the data
                  SocketClient := TcpClient.Create();
									SocketClient.Connect(TB_IPAddress0.Text + '.' + TB_IPAddress1.Text + '.'+
										TB_IPAddress2.Text + '.' + TB_IPAddress3.Text,8989);

									TB_Display.Text := TB_Display.Text + Environment.NewLine +  'Socket connected' + Environment.NewLine;
									TB_Display.Refresh();

									SocketClient.ReceiveBufferSize := 1048576;

									stream := SocketClient.GetStream();
									i_Error := MSXE3021.AnalogInputInitAndStartAutoRefresh	(ulChannelMask,pulGain,pulPolarity,ulAverageMode,ulAverageValue,ulConversionTime,
										ulConversionTimeUnit,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,0,0,0,syserrno);
									if (i_Error <> 0) then
                  Begin
										MessageBox.Show('AnalogInputInitAndStartAutoRefresh Error : ' + i_Error.ToString(), 'Function error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                  end
									else
                  Begin
										GB_AverageConfiguration.Enabled := false;
										GB_ChannelConfiguration.Enabled := false;
										GB_ConversionTimeConfiguration.Enabled := false;
										GB_DataFormat.Enabled := false;
										GB_TriggerConfiguration.Enabled := false;
										B_Start.Enabled := false;
										B_Stop.Enabled := true;
										Timer1.Enabled := true;
                  end;

                except
                  on E: Exception do MessageBox.Show('Exception occur : ' + e.Message, 'Function error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                end;
							End
							else
							Begin
								MessageBox.Show('The IP address (part 4) you enter is not valid, please try again.', 'IP address error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
							End;
						End
						else
						Begin
							MessageBox.Show('The IP address (part 3) you enter is not valid, please try again.', 'IP address error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						End;
					End
					else
					Begin
						MessageBox.Show('The IP address (part 2) you enter is not valid, please try again.', 'IP address error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					End;
				End
				else
				Begin
					MessageBox.Show('The IP address (part 1) you enter is not valid, please try again.', 'IP address error', MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				End;
			End;

end;

procedure TWinForm.TWinForm_Closed(sender: System.Object; e: System.EventArgs);
begin
  if (B_Stop.Enabled = True) then
    B_Stop_Click(sender,e);

  MSXE3021.Dispose();

end;

procedure TWinForm.TWinForm_Load(sender: System.Object; e: System.EventArgs);
begin
  MSXE3021 := MSXE3021WebReference.MSXE302x.MSXE302x.Create();
  MSXE3021.Timeout := 2000;
  B_Start.Enabled := True;
  B_Stop.Enabled := False;

  CB_ConversionTimeUnit.SelectedIndex := 1;


end;

end.
